diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-03-09 16:55:49.791372500 -0700
@@ -11,8 +11,10 @@
 #include "ht-configuration.h"
 
 #include "ns3/abort.h"
+#include "ns3/ap-wifi-mac.h"
 #include "ns3/assert.h"
 #include "ns3/ctrl-headers.h"
+#include "ns3/gcr-manager.h"
 #include "ns3/log.h"
 #include "ns3/mgt-action-headers.h"
 #include "ns3/recipient-block-ack-agreement.h"
@@ -62,6 +64,10 @@
 HtFrameExchangeManager::DoDispose()
 {
     NS_LOG_FUNCTION(this);
+    if (m_flushGroupcastMpdusEvent.IsPending())
+    {
+        m_flushGroupcastMpdusEvent.Cancel();
+    }
     m_pendingAddBaResp.clear();
     m_msduAggregator = nullptr;
     m_mpduAggregator = nullptr;
@@ -134,16 +140,57 @@
     return establish;
 }
 
+std::optional<Mac48Address>
+HtFrameExchangeManager::NeedSetupGcrBlockAck(const WifiMacHeader& header)
+{
+    NS_ASSERT(m_mac->GetTypeOfStation() == AP && m_apMac->UseGcr(header));
+    const auto& groupAddress = header.GetAddr1();
+
+    const auto tid = header.GetQosTid();
+    auto qosTxop = m_mac->GetQosTxop(tid);
+    const auto maxMpduSize =
+        m_mpduAggregator->GetMaxAmpduSize(groupAddress, tid, WIFI_MOD_CLASS_HT);
+    const auto isGcrBa = (m_apMac->GetGcrManager()->GetRetransmissionPolicy() ==
+                          GroupAddressRetransmissionPolicy::GCR_BLOCK_ACK);
+    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_GROUPCAST, groupAddress, tid};
+
+    for (const auto& recipients =
+             m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(groupAddress);
+         const auto& nextRecipient : recipients)
+    {
+        if (auto agreement =
+                qosTxop->GetBaManager()->GetAgreementAsOriginator(nextRecipient, tid, groupAddress);
+            agreement && !agreement->get().IsReset())
+        {
+            continue;
+        }
+
+        const auto packets = qosTxop->GetWifiMacQueue()->GetNPackets(queueId);
+        const auto establish =
+            (isGcrBa ||
+             (qosTxop->GetBlockAckThreshold() > 0 && packets >= qosTxop->GetBlockAckThreshold()) ||
+             (maxMpduSize > 0 && packets > 1));
+        NS_LOG_FUNCTION(this << groupAddress << +tid << establish);
+        if (establish)
+        {
+            return nextRecipient;
+        }
+    }
+
+    return std::nullopt;
+}
+
 bool
 HtFrameExchangeManager::SendAddBaRequest(Mac48Address dest,
                                          uint8_t tid,
                                          uint16_t startingSeq,
                                          uint16_t timeout,
                                          bool immediateBAck,
-                                         Time availableTime)
+                                         Time availableTime,
+                                         std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << dest << +tid << startingSeq << timeout << immediateBAck
-                         << availableTime);
+    NS_LOG_FUNCTION(this << dest << +tid << startingSeq << timeout << immediateBAck << availableTime
+                         << gcrGroupAddr.has_value());
     NS_LOG_DEBUG("Send ADDBA request to " << dest);
 
     WifiMacHeader hdr;
@@ -182,6 +229,11 @@
     // set the starting sequence number for the BA agreement
     reqHdr.SetStartingSequence(startingSeq);
 
+    if (gcrGroupAddr)
+    {
+        reqHdr.SetGcrGroupAddress(*gcrGroupAddr);
+    }
+
     GetBaManager(tid)->CreateOriginatorAgreement(reqHdr, dest);
 
     packet->AddHeader(reqHdr);
@@ -243,6 +295,11 @@
     respHdr.SetBufferSize(bufferSize);
     respHdr.SetTimeout(reqHdr.GetTimeout());
 
+    if (auto gcrGroupAddr = reqHdr.GetGcrGroupAddress())
+    {
+        respHdr.SetGcrGroupAddress(*gcrGroupAddr);
+    }
+
     WifiActionHeader actionHdr;
     WifiActionHeader::ActionValue action;
     action.blockAck = WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE;
@@ -262,7 +319,8 @@
                                                 reqHdr.GetStartingSequence(),
                                                 m_rxMiddle);
 
-    auto agreement = GetBaManager(tid)->GetAgreementAsRecipient(originator, tid);
+    auto agreement =
+        GetBaManager(tid)->GetAgreementAsRecipient(originator, tid, reqHdr.GetGcrGroupAddress());
     NS_ASSERT(agreement);
     if (respHdr.GetTimeout() != 0)
     {
@@ -274,7 +332,8 @@
                                 this,
                                 originator,
                                 tid,
-                                false);
+                                false,
+                                reqHdr.GetGcrGroupAddress());
     }
 
     auto mpdu = Create<WifiMpdu>(packet, hdr);
@@ -308,9 +367,12 @@
 }
 
 void
-HtFrameExchangeManager::SendDelbaFrame(Mac48Address addr, uint8_t tid, bool byOriginator)
+HtFrameExchangeManager::SendDelbaFrame(Mac48Address addr,
+                                       uint8_t tid,
+                                       bool byOriginator,
+                                       std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << addr << +tid << byOriginator);
+    NS_LOG_FUNCTION(this << addr << +tid << byOriginator << gcrGroupAddr.has_value());
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_MGT_ACTION);
     // use the remote link address if addr is an MLD address
@@ -323,6 +385,10 @@
     MgtDelBaHeader delbaHdr;
     delbaHdr.SetTid(tid);
     byOriginator ? delbaHdr.SetByOriginator() : delbaHdr.SetByRecipient();
+    if (gcrGroupAddr.has_value())
+    {
+        delbaHdr.SetGcrGroupAddress(gcrGroupAddr.value());
+    }
 
     WifiActionHeader actionHdr;
     WifiActionHeader::ActionValue action;
@@ -336,6 +402,17 @@
     m_mac->GetQosTxop(tid)->Queue(Create<WifiMpdu>(packet, hdr));
 }
 
+uint16_t
+HtFrameExchangeManager::GetBaAgreementStartingSequenceNumber(const WifiMacHeader& header)
+{
+    // if the peeked MPDU has been already transmitted, use its sequence number
+    // as the starting sequence number for the BA agreement, otherwise use the
+    // next available sequence number
+    return header.IsRetry()
+               ? header.GetSequenceNumber()
+               : m_txMiddle->GetNextSeqNumberByTidAndAddress(header.GetQosTid(), header.GetAddr1());
+}
+
 bool
 HtFrameExchangeManager::StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame)
 {
@@ -364,23 +441,29 @@
     if (hdr.IsQosData() && !hdr.GetAddr1().IsGroup() &&
         NeedSetupBlockAck(hdr.GetAddr1(), hdr.GetQosTid()))
     {
-        // if the peeked MPDU has been already transmitted, use its sequence number
-        // as the starting sequence number for the BA agreement, otherwise use the
-        // next available sequence number
-        uint16_t startingSeq =
-            (hdr.IsRetry()
-                 ? hdr.GetSequenceNumber()
-                 : m_txMiddle->GetNextSeqNumberByTidAndAddress(hdr.GetQosTid(), hdr.GetAddr1()));
         return SendAddBaRequest(hdr.GetAddr1(),
                                 hdr.GetQosTid(),
-                                startingSeq,
+                                GetBaAgreementStartingSequenceNumber(hdr),
                                 edca->GetBlockAckInactivityTimeout(),
                                 true,
                                 availableTime);
     }
+    else if (IsGcr(m_mac, hdr))
+    {
+        if (const auto addbaRecipient = NeedSetupGcrBlockAck(hdr))
+        {
+            return SendAddBaRequest(addbaRecipient.value(),
+                                    hdr.GetQosTid(),
+                                    GetBaAgreementStartingSequenceNumber(hdr),
+                                    edca->GetBlockAckInactivityTimeout(),
+                                    true,
+                                    availableTime,
+                                    hdr.GetAddr1());
+        }
+    }
 
     // Use SendDataFrame if we can try aggregation
-    if (hdr.IsQosData() && !hdr.GetAddr1().IsGroup() && !peekedItem->IsFragment() &&
+    if (hdr.IsQosData() && !hdr.GetAddr1().IsBroadcast() && !peekedItem->IsFragment() &&
         !GetWifiRemoteStationManager()->NeedFragmentation(peekedItem =
                                                               CreateAliasIfNeeded(peekedItem)))
     {
@@ -446,8 +529,20 @@
                 continue;
             }
 
-            auto agreement = m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid);
-            if (!agreement)
+            auto agreement = m_mac->GetBaAgreementEstablishedAsOriginator(
+                recipient,
+                tid,
+                reqHdr.IsGcr() ? std::optional{reqHdr.GetGcrGroupAddress()} : std::nullopt);
+            if (const auto isGcrBa =
+                    reqHdr.IsGcr() && (m_apMac->GetGcrManager()->GetRetransmissionPolicy() ==
+                                       GroupAddressRetransmissionPolicy::GCR_BLOCK_ACK);
+                agreement && reqHdr.IsGcr() && !isGcrBa)
+            {
+                NS_LOG_DEBUG("Skip GCR BAR if GCR-BA retransmission policy is not selected");
+                queue->Remove(bar);
+                continue;
+            }
+            else if (!agreement)
             {
                 NS_LOG_DEBUG("BA agreement with " << recipient << " for TID=" << +tid
                                                   << " was torn down");
@@ -509,7 +604,14 @@
         auto baManager = m_mac->GetQosTxop(ac)->GetBaManager();
         for (const auto& [recipient, tid] : baManager->GetSendBarIfDataQueuedList())
         {
-            if (queue->PeekByTidAndAddress(tid, recipient))
+            WifiContainerQueueId queueId(
+                WIFI_QOSDATA_QUEUE,
+                WIFI_UNICAST,
+                GetWifiRemoteStationManager()->GetMldAddress(recipient).value_or(recipient),
+                tid);
+            // check if data is queued and can be transmitted on this link
+            if (queue->PeekByTidAndAddress(tid, recipient) &&
+                !m_mac->GetTxBlockedOnLink(QosUtilsMapTidToAc(tid), queueId, m_linkId))
             {
                 auto [reqHdr, hdr] = m_mac->GetQosTxop(ac)->PrepareBlockAckRequest(recipient, tid);
                 auto pkt = Create<Packet>();
@@ -614,7 +716,7 @@
     {
         // a QoS data frame using the Block Ack policy can be followed by a BlockAckReq
         // frame and a BlockAck frame. Such a sequence is handled by the HT FEM
-        SendPsduWithProtection(Create<WifiPsdu>(mpdu, false), txParams);
+        SendPsduWithProtection(GetWifiPsdu(mpdu, txParams.m_txVector), txParams);
     }
     else
     {
@@ -634,22 +736,23 @@
     if (acknowledgment->method == WifiAcknowledgment::BLOCK_ACK)
     {
         auto blockAcknowledgment = static_cast<WifiBlockAck*>(acknowledgment);
-        Time baTxDuration = m_phy->CalculateTxDuration(GetBlockAckSize(blockAcknowledgment->baType),
-                                                       blockAcknowledgment->blockAckTxVector,
-                                                       m_phy->GetPhyBand());
+        auto baTxDuration =
+            WifiPhy::CalculateTxDuration(GetBlockAckSize(blockAcknowledgment->baType),
+                                         blockAcknowledgment->blockAckTxVector,
+                                         m_phy->GetPhyBand());
         blockAcknowledgment->acknowledgmentTime = m_phy->GetSifs() + baTxDuration;
     }
     else if (acknowledgment->method == WifiAcknowledgment::BAR_BLOCK_ACK)
     {
         auto barBlockAcknowledgment = static_cast<WifiBarBlockAck*>(acknowledgment);
-        Time barTxDuration =
-            m_phy->CalculateTxDuration(GetBlockAckRequestSize(barBlockAcknowledgment->barType),
-                                       barBlockAcknowledgment->blockAckReqTxVector,
-                                       m_phy->GetPhyBand());
-        Time baTxDuration =
-            m_phy->CalculateTxDuration(GetBlockAckSize(barBlockAcknowledgment->baType),
-                                       barBlockAcknowledgment->blockAckTxVector,
-                                       m_phy->GetPhyBand());
+        auto barTxDuration =
+            WifiPhy::CalculateTxDuration(GetBlockAckRequestSize(barBlockAcknowledgment->barType),
+                                         barBlockAcknowledgment->blockAckReqTxVector,
+                                         m_phy->GetPhyBand());
+        auto baTxDuration =
+            WifiPhy::CalculateTxDuration(GetBlockAckSize(barBlockAcknowledgment->baType),
+                                         barBlockAcknowledgment->blockAckTxVector,
+                                         m_phy->GetPhyBand());
         barBlockAcknowledgment->acknowledgmentTime =
             2 * m_phy->GetSifs() + barTxDuration + baTxDuration;
     }
@@ -685,6 +788,8 @@
         {
             // notify the BA manager that the MPDU was acknowledged
             edca->GetBaManager()->NotifyGotAck(m_linkId, mpdu);
+            // the BA manager fires the AckedMpdu trace source, so nothing else must be done
+            return;
         }
     }
     else if (mpdu->GetHeader().IsAction())
@@ -703,11 +808,15 @@
                 auto tid = delBa.GetTid();
                 if (delBa.IsByOriginator())
                 {
-                    GetBaManager(tid)->DestroyOriginatorAgreement(address, tid);
+                    GetBaManager(tid)->DestroyOriginatorAgreement(address,
+                                                                  tid,
+                                                                  delBa.GetGcrGroupAddress());
                 }
                 else
                 {
-                    GetBaManager(tid)->DestroyRecipientAgreement(address, tid);
+                    GetBaManager(tid)->DestroyRecipientAgreement(address,
+                                                                 tid,
+                                                                 delBa.GetGcrGroupAddress());
                 }
             }
             else if (actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
@@ -720,7 +829,8 @@
                                     &QosTxop::AddBaResponseTimeout,
                                     edca,
                                     address,
-                                    addBa.GetTid());
+                                    addBa.GetTid(),
+                                    addBa.GetGcrGroupAddress());
             }
             else if (actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE)
             {
@@ -728,9 +838,11 @@
                 MgtAddBaResponseHeader addBa;
                 p->PeekHeader(addBa);
                 auto tid = addBa.GetTid();
-                NS_ASSERT_MSG(GetBaManager(tid)->GetAgreementAsRecipient(address, tid),
-                              "Recipient BA agreement {" << address << ", " << +tid
-                                                         << "} not found");
+                NS_ASSERT_MSG(
+                    GetBaManager(tid)->GetAgreementAsRecipient(address,
+                                                               tid,
+                                                               addBa.GetGcrGroupAddress()),
+                    "Recipient BA agreement {" << address << ", " << +tid << "} not found");
                 m_pendingAddBaResp.erase({address, tid});
             }
         }
@@ -743,7 +855,8 @@
 {
     NS_LOG_DEBUG(this);
 
-    if (m_edca && m_edca->GetTxopLimit(m_linkId).IsZero() && GetBar(m_edca->GetAccessCategory()))
+    if (m_edca && m_edca->GetTxopLimit(m_linkId).IsZero() && GetBar(m_edca->GetAccessCategory()) &&
+        (m_txNav > Simulator::Now() + m_phy->GetSifs()))
     {
         // A TXOP limit of 0 indicates that the TXOP holder may transmit or cause to
         // be transmitted (as responses) the following within the current TXOP:
@@ -755,6 +868,12 @@
 
         // TXOP limit is null, hence the txopDuration parameter is unused
         Simulator::Schedule(m_phy->GetSifs(), fp, this, m_edca, Seconds(0));
+
+        if (m_protectedIfResponded)
+        {
+            m_protectedStas.merge(m_sentFrameTo);
+        }
+        m_sentFrameTo.clear();
     }
     else
     {
@@ -778,24 +897,34 @@
         if (actionHdr.GetCategory() == WifiActionHeader::BLOCK_ACK &&
             actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
         {
-            uint8_t tid = GetTid(mpdu->GetPacket(), mpdu->GetHeader());
+            const auto tid = GetTid(mpdu->GetPacket(), mpdu->GetHeader());
             auto recipient = mpdu->GetHeader().GetAddr1();
             // if the recipient is an MLD, use its MLD address
             if (auto mldAddr = GetWifiRemoteStationManager()->GetMldAddress(recipient))
             {
                 recipient = *mldAddr;
             }
-            if (auto agreement = GetBaManager(tid)->GetAgreementAsOriginator(recipient, tid);
+            auto p = mpdu->GetPacket()->Copy();
+            p->RemoveHeader(actionHdr);
+            MgtAddBaRequestHeader addBa;
+            p->PeekHeader(addBa);
+            if (auto agreement =
+                    GetBaManager(tid)->GetAgreementAsOriginator(recipient,
+                                                                tid,
+                                                                addBa.GetGcrGroupAddress());
                 agreement && agreement->get().IsPending())
             {
                 NS_LOG_DEBUG("No ACK after ADDBA request");
                 Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
-                qosTxop->NotifyOriginatorAgreementNoReply(recipient, tid);
+                qosTxop->NotifyOriginatorAgreementNoReply(recipient,
+                                                          tid,
+                                                          addBa.GetGcrGroupAddress());
                 Simulator::Schedule(qosTxop->GetFailedAddBaTimeout(),
                                     &QosTxop::ResetBa,
                                     qosTxop,
                                     recipient,
-                                    tid);
+                                    tid,
+                                    addBa.GetGcrGroupAddress());
             }
         }
     }
@@ -833,10 +962,20 @@
 {
     NS_LOG_FUNCTION(this << *psdu);
 
-    auto tids = psdu->GetTids();
+    const auto tids = psdu->GetTids();
+    const auto isGcr = IsGcr(m_mac, psdu->GetHeader(0));
+    auto agreementEstablished =
+        !tids.empty() /* no QoS data frame included */ &&
+        (isGcr ? GetBaManager(*tids.begin())
+                     ->IsGcrAgreementEstablished(
+                         psdu->GetHeader(0).GetAddr1(),
+                         *tids.begin(),
+                         m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(
+                             psdu->GetHeader(0).GetAddr1()))
+               : m_mac->GetBaAgreementEstablishedAsOriginator(psdu->GetAddr1(), *tids.begin())
+                     .has_value());
 
-    if (tids.empty() || // no QoS data frames included
-        !m_mac->GetBaAgreementEstablishedAsOriginator(psdu->GetAddr1(), *tids.begin()))
+    if (!agreementEstablished)
     {
         QosFrameExchangeManager::ReleaseSequenceNumbers(psdu);
         return;
@@ -853,7 +992,15 @@
         if (hdr.IsQosData())
         {
             uint8_t tid = hdr.GetQosTid();
-            NS_ASSERT(m_mac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr1(), tid));
+            agreementEstablished =
+                isGcr ? GetBaManager(tid)->IsGcrAgreementEstablished(
+                            psdu->GetHeader(0).GetAddr1(),
+                            tid,
+                            m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(
+                                psdu->GetHeader(0).GetAddr1()))
+                      : m_mac->GetBaAgreementEstablishedAsOriginator(psdu->GetAddr1(), tid)
+                            .has_value();
+            NS_ASSERT(agreementEstablished);
 
             if (!hdr.IsRetry() && !(*mpduIt)->IsInFlight())
             {
@@ -950,7 +1097,14 @@
     {
         m_protectedStas.merge(m_sentRtsTo);
         m_sentRtsTo.clear();
-        SendPsdu();
+        if (m_txParams.m_protection->method == WifiProtection::NONE)
+        {
+            SendPsdu();
+        }
+        else
+        {
+            Simulator::Schedule(m_phy->GetSifs(), &HtFrameExchangeManager::SendPsdu, this);
+        }
         return;
     }
     QosFrameExchangeManager::ProtectionCompleted();
@@ -979,22 +1133,57 @@
     NS_LOG_FUNCTION(this);
 
     Time txDuration =
-        m_phy->CalculateTxDuration(m_psdu->GetSize(), m_txParams.m_txVector, m_phy->GetPhyBand());
+        WifiPhy::CalculateTxDuration(m_psdu->GetSize(), m_txParams.m_txVector, m_phy->GetPhyBand());
 
     NS_ASSERT(m_txParams.m_acknowledgment);
 
     if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
     {
-        Simulator::Schedule(txDuration, &HtFrameExchangeManager::TransmissionSucceeded, this);
-
         std::set<uint8_t> tids = m_psdu->GetTids();
         NS_ASSERT_MSG(tids.size() <= 1, "Multi-TID A-MPDUs are not supported");
 
-        if (tids.empty() || m_psdu->GetAckPolicyForTid(*tids.begin()) == WifiMacHeader::NO_ACK)
+        if (m_mac->GetTypeOfStation() == AP && m_apMac->UseGcr(m_psdu->GetHeader(0)))
+        {
+            if (m_apMac->GetGcrManager()->KeepGroupcastQueued(*m_psdu->begin()))
+            {
+                // keep the groupcast frame in the queue for future retransmission
+                Simulator::Schedule(txDuration + m_phy->GetSifs(), [=, this, psdu = m_psdu]() {
+                    NS_LOG_DEBUG("Prepare groupcast PSDU for retry");
+                    for (const auto& mpdu : *PeekPointer(psdu))
+                    {
+                        mpdu->ResetInFlight(m_linkId);
+                        // restore addr1 to the group address instead of the concealment address
+                        if (m_apMac->GetGcrManager()->UseConcealment(mpdu->GetHeader()))
+                        {
+                            mpdu->GetHeader().SetAddr1(mpdu->begin()->second.GetDestinationAddr());
+                        }
+                        mpdu->GetHeader().SetRetry();
+                    }
+                });
+            }
+            else
+            {
+                if (m_apMac->GetGcrManager()->GetRetransmissionPolicy() ==
+                    GroupAddressRetransmissionPolicy::GCR_UNSOLICITED_RETRY)
+                {
+                    for (const auto& mpdu : *PeekPointer(m_psdu))
+                    {
+                        NotifyLastGcrUrTx(mpdu);
+                    }
+                }
+                DequeuePsdu(m_psdu);
+            }
+        }
+        else if (tids.empty() || m_psdu->GetAckPolicyForTid(*tids.begin()) == WifiMacHeader::NO_ACK)
         {
             // No acknowledgment, hence dequeue the PSDU if it is stored in a queue
             DequeuePsdu(m_psdu);
         }
+
+        Simulator::Schedule(txDuration, [=, this]() {
+            TransmissionSucceeded();
+            m_psdu = nullptr;
+        });
     }
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::BLOCK_ACK)
     {
@@ -1007,7 +1196,7 @@
 
         Time timeout =
             txDuration + m_phy->GetSifs() + m_phy->GetSlot() +
-            m_phy->CalculatePhyPreambleAndHeaderDuration(blockAcknowledgment->blockAckTxVector);
+            WifiPhy::CalculatePhyPreambleAndHeaderDuration(blockAcknowledgment->blockAckTxVector);
         NS_ASSERT(!m_txTimer.IsRunning());
         m_txTimer.Set(WifiTxTimer::WAIT_BLOCK_ACK,
                       timeout,
@@ -1023,16 +1212,43 @@
         m_psdu->SetDuration(GetPsduDurationId(txDuration, m_txParams));
 
         // schedule the transmission of a BAR in a SIFS
-        std::set<uint8_t> tids = m_psdu->GetTids();
+        const auto tids = m_psdu->GetTids();
         NS_ABORT_MSG_IF(tids.size() > 1,
                         "Acknowledgment method incompatible with a Multi-TID A-MPDU");
-        uint8_t tid = *tids.begin();
+        const auto tid = *tids.begin();
 
-        Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
-        auto [reqHdr, hdr] = edca->PrepareBlockAckRequest(m_psdu->GetAddr1(), tid);
-        GetBaManager(tid)->ScheduleBar(reqHdr, hdr);
+        auto edca = m_mac->GetQosTxop(tid);
+        const auto isGcr = IsGcr(m_mac, m_psdu->GetHeader(0));
+        const auto& recipients =
+            isGcr ? m_apMac->GetGcrManager()->GetMemberStasForGroupAddress(m_psdu->GetAddr1())
+                  : GcrManager::GcrMembers{m_psdu->GetAddr1()};
+        std::optional<Mac48Address> gcrGroupAddress{isGcr ? std::optional{m_psdu->GetAddr1()}
+                                                          : std::nullopt};
+        for (const auto& recipient : recipients)
+        {
+            auto [reqHdr, hdr] = edca->PrepareBlockAckRequest(recipient, tid, gcrGroupAddress);
+            GetBaManager(tid)->ScheduleBar(reqHdr, hdr);
+        }
+
+        if (isGcr)
+        {
+            Simulator::Schedule(txDuration + m_phy->GetSifs(), [=, this, psdu = m_psdu]() {
+                NS_LOG_DEBUG("Restore group address of PSDU");
+                for (const auto& mpdu : *PeekPointer(psdu))
+                {
+                    // restore addr1 to the group address instead of the concealment address
+                    if (m_apMac->GetGcrManager()->UseConcealment(mpdu->GetHeader()))
+                    {
+                        mpdu->GetHeader().SetAddr1(mpdu->begin()->second.GetDestinationAddr());
+                    }
+                }
+            });
+        }
 
-        Simulator::Schedule(txDuration, &HtFrameExchangeManager::TransmissionSucceeded, this);
+        Simulator::Schedule(txDuration, [=, this]() {
+            TransmissionSucceeded();
+            m_psdu = nullptr;
+        });
     }
     else
     {
@@ -1050,6 +1266,12 @@
         ForwardMpduDown(*m_psdu->begin(), m_txParams.m_txVector);
     }
 
+    if (m_txTimer.IsRunning())
+    {
+        NS_ASSERT(m_sentFrameTo.empty());
+        m_sentFrameTo = {m_psdu->GetAddr1()};
+    }
+
     if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
     {
         // we are done in case the A-MPDU does not require acknowledgment
@@ -1103,6 +1325,14 @@
                 hdr.SetQosEosp();
                 hdr.SetQosQueueSize(queueSizeForTid[tid].value());
             }
+
+            if (m_mac->GetTypeOfStation() == AP && m_apMac->UseGcr(hdr) &&
+                m_apMac->GetGcrManager()->UseConcealment(mpdu->GetHeader()))
+            {
+                const auto& gcrConcealmentAddress =
+                    m_apMac->GetGcrManager()->GetGcrConcealmentAddress();
+                hdr.SetAddr1(gcrConcealmentAddress);
+            }
         }
     }
 
@@ -1112,8 +1342,7 @@
 void
 HtFrameExchangeManager::DequeuePsdu(Ptr<const WifiPsdu> psdu)
 {
-    NS_LOG_DEBUG(this << psdu);
-
+    NS_LOG_FUNCTION(this << *psdu);
     for (const auto& mpdu : *PeekPointer(psdu))
     {
         DequeueMpdu(mpdu);
@@ -1135,6 +1364,15 @@
         txVector.SetAggregation(true);
     }
 
+    auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
+    // The TXNAV timer is a single timer, shared by the EDCAFs within a STA, that is initialized
+    // with the duration from the Duration/ID field in the frame most recently successfully
+    // transmitted by the TXOP holder, except for PS-Poll frames. (Sec.10.23.2.2 IEEE 802.11-2020)
+    if (!psdu->GetHeader(0).IsPsPoll())
+    {
+        m_txNav = Max(m_txNav, Simulator::Now() + txDuration + psdu->GetDuration());
+    }
+
     m_phy->Send(psdu, txVector);
 }
 
@@ -1339,35 +1577,22 @@
 
     GetWifiRemoteStationManager()->ReportDataFailed(*psdu->begin());
 
-    bool resetCw;
-    MissedBlockAck(psdu, txVector, resetCw);
-
-    NS_ASSERT(m_edca);
-
-    if (resetCw)
-    {
-        m_edca->ResetCw(m_linkId);
-    }
-    else
-    {
-        m_edca->UpdateFailedCw(m_linkId);
-    }
+    MissedBlockAck(psdu, txVector);
 
     m_psdu = nullptr;
     TransmissionFailed();
 }
 
 void
-HtFrameExchangeManager::MissedBlockAck(Ptr<WifiPsdu> psdu,
-                                       const WifiTxVector& txVector,
-                                       bool& resetCw)
+HtFrameExchangeManager::MissedBlockAck(Ptr<WifiPsdu> psdu, const WifiTxVector& txVector)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector << resetCw);
+    NS_LOG_FUNCTION(this << psdu << txVector);
 
     auto recipient = psdu->GetAddr1();
     auto recipientMld = GetWifiRemoteStationManager()->GetMldAddress(recipient).value_or(recipient);
     bool isBar;
     uint8_t tid;
+    std::optional<Mac48Address> gcrGroupAddress;
 
     if (psdu->GetNMpdus() == 1 && psdu->GetHeader(0).IsBlockAckReq())
     {
@@ -1375,6 +1600,10 @@
         CtrlBAckRequestHeader baReqHdr;
         psdu->GetPayload(0)->PeekHeader(baReqHdr);
         tid = baReqHdr.GetTidInfo();
+        if (baReqHdr.IsGcr())
+        {
+            gcrGroupAddress = baReqHdr.GetGcrGroupAddress();
+        }
     }
     else
     {
@@ -1383,6 +1612,15 @@
         NS_ABORT_MSG_IF(tids.size() > 1, "Multi-TID A-MPDUs not handled here");
         NS_ASSERT(!tids.empty());
         tid = *tids.begin();
+
+        GetWifiRemoteStationManager()
+            ->ReportAmpduTxStatus(recipient, 0, psdu->GetNMpdus(), 0, 0, txVector);
+
+        if (auto droppedMpdu = DropMpduIfRetryLimitReached(psdu))
+        {
+            // notify remote station manager if at least an MPDU was dropped
+            GetWifiRemoteStationManager()->ReportFinalDataFailed(droppedMpdu);
+        }
     }
 
     Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
@@ -1390,7 +1628,13 @@
     if (edca->UseExplicitBarAfterMissedBlockAck() || isBar)
     {
         // we have to send a BlockAckReq, if needed
-        if (GetBaManager(tid)->NeedBarRetransmission(tid, recipientMld))
+        const auto retransmitBar =
+            gcrGroupAddress.has_value()
+                ? GetBaManager(tid)->NeedGcrBarRetransmission(gcrGroupAddress.value(),
+                                                              recipientMld,
+                                                              tid)
+                : GetBaManager(tid)->NeedBarRetransmission(tid, recipientMld);
+        if (retransmitBar)
         {
             NS_LOG_DEBUG("Missed Block Ack, transmit a BlockAckReq");
             /**
@@ -1413,14 +1657,12 @@
                 auto [reqHdr, hdr] = edca->PrepareBlockAckRequest(recipient, tid);
                 GetBaManager(tid)->ScheduleBar(reqHdr, hdr);
             }
-            resetCw = false;
         }
         else
         {
             NS_LOG_DEBUG("Missed Block Ack, do not transmit a BlockAckReq");
             // if a BA agreement exists, we can get here if there is no outstanding
             // MPDU whose lifetime has not expired yet.
-            GetWifiRemoteStationManager()->ReportFinalDataFailed(*psdu->begin());
             if (isBar)
             {
                 DequeuePsdu(psdu);
